Description

It should be possible to define some classes as disabled (or not browsable), so you wont see them when selecting classes.

this mostly useful for classes which are internally used (within puppet) but you still want to be able to browse their puppetdoc.

Related issues:

Is duplicate of Foreman - Feature #933: Hide some puppet classes in Foreman Duplicate 05/24/2011

History

#1 - 11/09/2010 08:07 AM - Ohad Levy

- Target version set to 0.2

#2 - 03/15/2011 03:10 AM - Ohad Levy

- Target version deleted (0.2)

#3 - 03/18/2011 06:43 AM - Paul Kelly

- Status changed from New to Ready For Testing

#4 - 05/10/2011 04:39 AM - Paul Kelly

rebased and tested

#5 - 05/11/2011 05:01 AM - Paul Kelly

Contract all the long searches into a scope i.e. obj.hostgroup and obj.hostgroup.puppetclasses and (klasses =

obj.hostgroup.puppetclasses.visible_is(true)).is_a?(Array) and obj.is_a?(Host)

Set the default scope to only show visible classes

Update the search facility to allow visible to be used as a search target

When importing classes, all classes should be imported but a facility should be provided so that some can be marked as invisible

Update puppetdoc construction so that invisible classes are not processed

Provide a "toggle all" facility on the puppetclasses page. Use this:

function checkAll (id, checked) {

$(id).find(":checkbox:not([disabled='disabled'])").attr('checked',checked)

}

Provide a multiple interface so that this operation can be performed on large numbers of classes at once.

#6 - 05/24/2011 06:56 AM - Ohad Levy

- Status changed from Ready For Testing to Duplicate

#7 - 05/24/2011 06:56 AM - Ohad Levy

- Status changed from Duplicate to New

#8 - 07/17/2012 05:44 AM - Romain Vrignaud

- Assignee changed from Paul Kelly to Jean-Sébastien Pédron

05/10/2024 1/2



#9 - 07/18/2012 10:07 AM - Jean-Sébastien Pédron

I pushed the first version of the patch I'm working on to implement this feature.

There're two parts:

1. The smart-proxy is modified to read modelines in Puppet classes' documentation. At this stage, the modeline content isn't parsed at all: only the

"foreman:" prefix is read by the smart-proxy. The text following the prefix is then transfered as-is to Foreman.

2. Foreman is modified to parse the modelines sent by the smart-proxy and store it in the database. A modeline is a one-line JSON hash. Later,

when editing a host or a hostgroup for instance, the modeline is used to determine if a Puppet class should be displayed. A new button allows

one to toggle the display of internal classes.

Here's an example of a modeline in a Puppet class:

# Class: mymodule::myclass

#

# foreman: { internal-class }

class mymodule::myclass {

    ...

}

The branches are on Github at the moment:

https://github.com/yakaz/smart-proxy/tree/modeline

https://github.com/yakaz/foreman/tree/fix418-hide-internal-puppet-classes

Caveat:

Both branches are based on Olivier Favre's branches regarding Parameterized classes, because I needed the modifications to the protocol

between the smart-proxy and Foreman.

#10 - 07/18/2012 10:29 AM - Ohad Levy

- Target version set to 1.1

#11 - 11/28/2012 05:33 AM - Ohad Levy

- Status changed from New to Resolved

- Assignee changed from Jean-Sébastien Pédron to Amos Benari

this is actually already resolved as part of the parameterized classes support.

foreman includes a file config/ignored_environments.yml.sample which contains examples of class names to ignore

or regular expressions of class names to be ignored.

#12 - 10/08/2015 03:29 AM - Sher Chowdhury

I wanted my foreman to only display my roles and profiles classes only. I achieved this by creating this file:

$ cat /usr/share/foreman/config/ignored_environments.yml

#:ignored:

#  - test

:filters:

  - !ruby/regexp '/^(?!role|profile).*$/'

 This didn't work at first but then I realized that it does work as long as you create this file before doing any foreman class/environment imports.

Hope this helps for anyone else having issues using the ignored_environments.yml file.
